﻿using RimWorld;
using System.Collections.Generic;
using System.Text;
using Verse;

namespace MinchoWitch
{
    public class Alert_MinchoInfection : Alert
    {
        public Alert_MinchoInfection()
        {
            defaultLabel = "Alert_MinchoInfection".Translate();
            defaultPriority = AlertPriority.High;
        }

        private List<Pawn> MinchoInfectionPawns
        {
            get
            {
                MinchoInfectionPawnsResult.Clear();
                List<Pawn> list = PawnsFinder.AllMaps_SpawnedPawnsInFaction(Faction.OfPlayer);
                for (int i = 0; i < list.Count; i++)
                {
                    Pawn pawn = list[i];
                    if (pawn.health != null && !pawn.RaceProps.Animal && pawn.health.hediffSet.GetFirstHediffOfDef(HediffDef.Named("Mincho_Infection"), true) != null)
                    {
                        MinchoInfectionPawnsResult.Add(pawn);
                    }
                }
                return MinchoInfectionPawnsResult;
            }
        }

        public override TaggedString GetExplanation()
        {
            StringBuilder stringBuilder = new StringBuilder();
            foreach (Pawn pawn in MinchoInfectionPawns)
            {
                stringBuilder.AppendLine("  - " + pawn.NameShortColored.Resolve());
            }
            return string.Format("Alert_MinchoInfectionDesc".Translate(), stringBuilder.ToString());
        }

        public override AlertReport GetReport()
        {
            return AlertReport.CulpritsAre(MinchoInfectionPawns);
        }
        private List<Pawn> MinchoInfectionPawnsResult = new List<Pawn>();
    }
}