﻿using RimWorld;
using Verse;

namespace MinchoWitch
{
    public class CompAbilityEffect_Spawn_Berserk : CompAbilityEffect
    {
        public new CompProperties_AbilitySpawn Props
        {
            get
            {
                return (CompProperties_AbilitySpawn)props;
            }
        }
        public override void Apply(LocalTargetInfo target, LocalTargetInfo dest)
        {
            Pawn pawn = PawnGenerator.GeneratePawn(PawnKindDef.Named("MinchoWitch_MinchoGolem"), null);
            pawn.mindState.mentalStateHandler.TryStartMentalState(MentalStateDefOf.Berserk, null, true, false, null, false);
            base.Apply(target, dest);
            GenSpawn.Spawn(pawn, target.Cell, parent.pawn.Map, WipeMode.Vanish);
            pawn.ageTracker.AgeBiologicalTicks = 0;
            pawn.ageTracker.AgeChronologicalTicks = 0;
            pawn.mindState.mentalStateHandler.TryStartMentalState(MentalStateDefOf.Berserk, null, true, false, null, false);
        }
        public override bool Valid(LocalTargetInfo target, bool throwMessages = false)
        {
            if (target.Cell.Filled(parent.pawn.Map))
            {
                if (throwMessages)
                {
                    Messages.Message("AbilityOccupiedCells".Translate(parent.def.LabelCap), target.ToTargetInfo(parent.pawn.Map), MessageTypeDefOf.RejectInput, false);
                }
                return false;
            }
            return true;
        }
    }
}
