﻿using HarmonyLib;
using RimWorld;
using System;
using System.Linq;
using Verse;

//Original code by FP
namespace MinchoWitch
{
    [StaticConstructorOnStartup]
    public static class Harmony_TryFindRandomShellDef
    {
        static Harmony_TryFindRandomShellDef()
        {
            Harmony harmonyInstance = new Harmony("MinchoWitch");
            harmonyInstance.Patch(AccessTools.Method(typeof(TurretGunUtility), "TryFindRandomShellDef", null, null), null, new HarmonyMethod(patchType, "TryFindRandomShellDefPostFix", null), null, null);
            Log.Message("MinchoWitch_patched");
        }

        [HarmonyPostfix]
        public static void TryFindRandomShellDefPostFix(ref ThingDef __result, ThingDef turret, bool allowEMP = true, bool mustHarmHealth = true, TechLevel techLevel = TechLevel.Undefined, bool allowAntigrainWarhead = false, float maxMarketValue = -1f)
        {
            if (__result != null)
            {
                if (__result.defName == "MinchoWitch_AppleCake")
                {
                    if (!TurretGunUtility.NeedsShells(turret))
                    {
                        __result = null;
                    }
                    ThingFilter fixedFilter = turret.building.turretGunDef.building.fixedStorageSettings.filter;
                    ThingDef result;
                    if ((from x in DefDatabase<ThingDef>.AllDefsListForReading
                         where fixedFilter.Allows(x) && (allowEMP || x.projectileWhenLoaded.projectile.damageDef != DamageDefOf.EMP) && (!mustHarmHealth || x.projectileWhenLoaded.projectile.damageDef.harmsHealth) && (techLevel == TechLevel.Undefined || x.techLevel <= techLevel) && (allowAntigrainWarhead || x != ThingDefOf.Shell_AntigrainWarhead) && (maxMarketValue < 0f || x.BaseMarketValue <= maxMarketValue) && x.defName != "MinchoWitch_AppleCake"
                         select x).TryRandomElement(out result))
                    {
                        __result = result;
                    }
                    else
                    {
                        __result = null;
                    }
                }
            }
        }


        private static readonly Type patchType = typeof(Harmony_TryFindRandomShellDef);
    }
}
