﻿using RimWorld;
using System.Linq;
using Verse;

namespace MinchoWitch
{
    public class IncidentWorker_WandererJoin_SetName : IncidentWorker_WandererJoin
    {
        public new bool CanFireNow(IncidentParms parms)
        {
            foreach (var pawn in PawnsFinder.AllMaps)
            {
                if (pawn.kindDef == this.def.pawnKind)
                {
                    return false;
                }
            }
            return base.CanFireNow(parms);
        }
        public override Pawn GeneratePawn()
        {
            Gender? fixedGender = null;
            if (this.def.pawnFixedGender != Gender.None)
            {
                fixedGender = new Gender?(this.def.pawnFixedGender);
            }
            Ideo ideo = null;
            if (ModsConfig.IdeologyActive)
            {
                ideo = (from i in Find.IdeoManager.IdeosListForReading
                        where !Faction.OfPlayer.ideos.Has(i)
                        select i).RandomElementWithFallback(null);
                if (ideo == null)
                {
                    ideo = (from i in Find.IdeoManager.IdeosListForReading
                            where !Faction.OfPlayer.ideos.IsPrimary(i)
                            select i).RandomElementWithFallback(null);
                }
            }
            Pawn pawn = PawnGenerator.GeneratePawn(new PawnGenerationRequest(this.def.pawnKind, Faction.OfPlayer, PawnGenerationContext.NonPlayer, -1, true, false, false, false, true, this.def.pawnMustBeCapableOfViolence, 20f, false, true, true, true, false, false, false, false, 0f, 0f, null, 1f, null, null, null, null, null, null, null, fixedGender, null, null, null, null, ideo, false, false, false));
            pawn.Name = new NameTriple("Marilyn".Translate(), "Minchowitch".Translate(), "Recats".Translate());
            return pawn;
        }
    }
}