﻿using HarmonyLib;
using System;
using Verse;

namespace MinchoWitch
{
    [StaticConstructorOnStartup]
    public static class Harmony_AddHediff
    {
        static Harmony_AddHediff()
        {
            Harmony harmonyInstance = new Harmony("MinchoWitch");

            harmonyInstance.Patch(AccessTools.Method(typeof(Pawn_HealthTracker), "AddHediff", new Type[]
             {
                typeof(Hediff),
                typeof(BodyPartRecord),
                typeof(DamageInfo?),
                typeof(DamageWorker.DamageResult)
              }, null), new HarmonyMethod(patchType, "AddHediffPrefix", null), null, null, null);
            Log.Message("MinchoWitch_patched");
        }

        [HarmonyPrefix]
        public static bool AddHediffPrefix(ref Pawn ___pawn, Hediff hediff, BodyPartRecord part = null, DamageInfo? dinfo = null, DamageWorker.DamageResult result = null)
        {
            if (___pawn.def.defName == "MinchoWitch")
            {
                switch (hediff.def.defName)
                {
                    case "Mincho_Brain_Freeze":
                    case "Mincho_Infection":
                    case "Mincho_Infection_Instant":
                        return false;
                }
            }
            return true;
        }
        private static readonly Type patchType = typeof(Harmony_AddHediff);
    }
}
