﻿using HarmonyLib;
using RimWorld;
using System;
using Verse;

//Original code by FP
namespace MinchoWitch
{
    [StaticConstructorOnStartup]
    public static class Harmony_MinchoWitch_AddPsychicAmplifier
    {
        static Harmony_MinchoWitch_AddPsychicAmplifier()
        {
            Harmony harmonyInstance = new Harmony("MinchoWitch");
            harmonyInstance.Patch(AccessTools.Method(typeof(PawnGenerator), "GenerateInitialHediffs", null, null), null, new HarmonyMethod(patchType, "GenerateInitialHediffsPostFix", null), null, null);
            Log.Message("MinchoWitch_patched");
        }

        [HarmonyPostfix]
        public static void GenerateInitialHediffsPostFix(Pawn pawn, PawnGenerationRequest request)
        {
            bool flag = pawn.def.defName == "MinchoWitch";
            if (flag)
            {
                Hediff hediff = HediffMaker.MakeHediff(HediffDefOf.PsychicAmplifier, pawn, pawn.health.hediffSet.GetBrain());
                hediff.Severity = 1f;
                pawn.health.AddHediff(hediff, null, null, null);
            }
        }


        private static readonly Type patchType = typeof(Harmony_MinchoWitch_AddPsychicAmplifier);
    }
}
