﻿using RimWorld;
using System.Linq;
using Verse;

namespace MinchoWitch
{
    public class IncidentWorker_WandererJoin_SetName : IncidentWorker_WandererJoin
    {
        public new bool CanFireNow(IncidentParms parms)
        {
            foreach (var pawn in PawnsFinder.AllMaps)
            {
                if (pawn.kindDef == this.def.pawnKind)
                {
                    return false;
                }
            }
            return base.CanFireNow(parms);
        }
        public override Pawn GeneratePawn()
        {
            Gender? fixedGender = null;
            if (this.def.pawnFixedGender != Gender.None)
            {
                fixedGender = new Gender?(this.def.pawnFixedGender);
            }
            Ideo ideo = null;
            if (ModsConfig.IdeologyActive)
            {
                ideo = (from i in Find.IdeoManager.IdeosListForReading
                        where !Faction.OfPlayer.ideos.Has(i)
                        select i).RandomElementWithFallback(null);
                if (ideo == null)
                {
                    ideo = (from i in Find.IdeoManager.IdeosListForReading
                            where !Faction.OfPlayer.ideos.IsPrimary(i)
                            select i).RandomElementWithFallback(null);
                }
            }
            Pawn pawn = PawnGenerator.GeneratePawn(new PawnGenerationRequest(kind: this.def.pawnKind, faction: Faction.OfPlayer, context: PawnGenerationContext.NonPlayer, -1, fixedGender: fixedGender));
            pawn.Name = new NameTriple("Marilyn".Translate(), "Minchowitch".Translate(), "Recats".Translate());
            return pawn;
        }
    }
}